      subroutine pre_step3d (tile)      


      use Agrif_Util
#include "Param_BeforeCall_pre_step3d.h"
      integer(4) :: tile
      

        call Sub_Loop_pre_step3d(tile, Agrif_tabvars_i(16)%iarray0, Agri
     &f_tabvars_i(15)%iarray0, Agrif_tabvars(117)%array3, Agrif_tabvars(
     &116)%array3, Agrif_tabvars_i(8)%iarray0, Agrif_tabvars_i(7)%iarray
     &0, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_
     &tabvars_i(13)%iarray0, Agrif_tabvars_i(2)%iarray0)

      end


#include "Sub_Loop_pre_step3d.h"
      subroutine pre_step3d_tile (Istr,Iend,Jstr,Jend, ru,rv,rw,
     &                                                 FC,CF,DC,
     &                                               FX,FE,WORK
     &                                                 ,Hz_half
     &                                                         )      


      use Agrif_Util
#include "Param_BeforeCall_pre_step3d_tile.h"
      integer(4) :: Istr
      integer(4) :: Iend
      integer(4) :: Jstr
      integer(4) :: Jend
      real, dimension(Istr-2:Iend+2,Jstr-2:Jend+2,1:N) :: ru
      real, dimension(Istr-2:Iend+2,Jstr-2:Jend+2,1:N) :: rv
      real, dimension(Istr-2:Iend+2,Jstr-2:Jend+2,0:N) :: rw
      real, dimension(Istr-2:Iend+2,0:N) :: FC
      real, dimension(Istr-2:Iend+2,0:N) :: CF
      real, dimension(Istr-2:Iend+2,0:N) :: DC
      real, dimension(Istr-2:Iend+2,Jstr-2:Jend+2) :: FX
      real, dimension(Istr-2:Iend+2,Jstr-2:Jend+2) :: FE
      real, dimension(Istr-2:Iend+2,Jstr-2:Jend+2) :: WORK
      real, dimension(Istr-2:Iend+2,Jstr-2:Jend+2,1:N) :: Hz_half
      

        call Sub_Loop_pre_step3d_tile(Istr,Iend,Jstr,Jend,ru,rv,rw,FC,CF
     &,DC,FX,FE,WORK,Hz_half, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars
     &_i(4)%iarray0, Agrif_tabvars_i(13)%iarray0, Agrif_tabvars_i(2)%iar
     &ray0, Agrif_tabvars(155)%array2, Agrif_tabvars_i(150)%iarray0, Agr
     &if_tabvars(75)%array3, Agrif_tabvars(149)%array4, Agrif_tabvars(91
     &)%array2, Agrif_tabvars(93)%array2, Agrif_tabvars(150)%array4, Agr
     &if_tabvars(94)%array2, Agrif_tabvars(92)%array2, Agrif_tabvars_i(1
     &55)%iarray0, Agrif_tabvars(78)%array2, Agrif_tabvars(79)%array2, A
     &grif_tabvars(148)%array5, Agrif_tabvars_i(8)%iarray0, Agrif_tabvar
     &s_i(7)%iarray0, Agrif_tabvars(141)%array3, Agrif_tabvars(144)%arra
     &y3, Agrif_tabvars(145)%array3, Agrif_tabvars(103)%array2, Agrif_ta
     &bvars(104)%array2, Agrif_tabvars(147)%array3, Agrif_tabvars(143)%a
     &rray3, Agrif_tabvars_r(3)%array0, Agrif_tabvars_i(158)%iarray0, Ag
     &rif_tabvars_i(147)%iarray0, Agrif_tabvars_i(153)%iarray0, Agrif_ta
     &bvars_l(13)%larray0, Agrif_tabvars_l(14)%larray0, Agrif_tabvars_l(
     &11)%larray0, Agrif_tabvars_l(12)%larray0)

      end


#include "Sub_Loop_pre_step3d_tile.h"
